@echo off

rem goto exit

if "%1" == "work" goto work
if "%1" == "" goto start
goto work_1



:start
if exist log.txt del log.txt

echo BEGIN ********************************************************************	>> log.txt
date /t																			>> log.txt
time /t																			>> log.txt
echo.																			>> log.txt
date /t
time /t

call %0 work sio4_driver	.\driver		sio4.sln			sio4.rta			sio4.rta

call %0 work sio4_docsrc	.\docsrc		sio4_dsl.sln		sio4_dsl.lib		sio4_dsl.lib
call %0 work sync_docsrc	.\sync\docsrc	docsrc.sln			sio4_sync_dsl.lib	sio4_sync_dsl.lib

call %0 work sio4_utils		.\utils			sio4_utils.sln		gsc_utils.lib		sio4_utils.lib
call %0 work hdlc_utils		.\hdlc\utils	utils.sln			sio4_hdlc_utils.lib	sio4_hdlc_utils.lib
call %0 work sync_utils		.\sync\utils	utils.sln			sio4_sync_utils.lib	sio4_sync_utils.lib

call %0 work sio4_lib		.\lib			sio4_lib.sln		sio4_lib.lib		sio4_lib.lib
call %0 work hdlc_lib		.\hdlc\lib		lib.sln				sio4_hdlc.lib		sio4_hdlc.lib
call %0 work sync_lib		.\sync\lib		lib.sln				sio4_sync.lib		sio4_sync.lib

call %0 work sio4_exit		.\exit			exit.sln			exit.rta			exit.rta
call %0 work sio4_id		.\id			id.sln				id.rta				id.rta
call %0 work sio4_irq		.\irq			irq.sln				irq.rta				irq.rta
call %0 work sio4_led		.\led			led.sln				led.rta				led.rta
call %0 work sio4_drvr_mbox	.\drvr_mbox		drvr_mbox.sln		drvr_mbox.rta		drvr_mbox.rta
call %0 work sio4_regs		.\regs			regs.sln			regs.rta			regs.rta
call %0 work sio4_services	.\services		services.sln		services.rta		services.rta
call %0 work sio4_txrate	.\txrate		txrate.sln			txrate.rta			txrate.rta

call %0 work sync_syncc2c	.\sync\syncc2c	syncc2c.sln			syncc2c.rta			syncc2c.rta

rem This is for internal use only.
if exist .\sync\libtest call %0 work sync_libtest	.\sync\libtest	libtest.sln			libtest.rta			libtest.rta



date /t
time /t
echo.																			>> log.txt
date /t																			>> log.txt
time /t																			>> log.txt
echo DONE *********************************************************************	>> log.txt

goto end



:work

set MVS="C:\Program Files\Microsoft Visual Studio 9.0\Common7\IDE\devenv.exe"
if not exist %MVS% goto mvs

if "%2" == "" goto work_2
if "%3" == "" goto work_3
if "%4" == "" goto work_4
if "%5" == "" goto work_5
if "%6" == "" goto work_6
set name=%2
set dir=%3
set sln=%3\%4
set target_1=%5
set target_2=%6
if not exist "%dir%"	goto dir
if not exist "%sln%"	goto sln
set t1=%dir%\Debug\%target_1%
set t2=%dir%\Debug\%target_2%

echo %name%: Cleaning ...

echo.																			>> log.txt
echo **** %name%: Cleaning (Debug) ********************************************	>> log.txt
echo.																			>> log.txt
%MVS% %sln% /Clean "Debug|Win32" /Out log.txt
if exist "%t1%"	echo **** FAIL: CLEAN: %t1% **********
if exist "%t1%"	echo **** FAIL: CLEAN: %t1% **********							>> log.txt

echo.																			>> log.txt
echo **** %name%: Cleaning (Release) ******************************************	>> log.txt
echo.																			>> log.txt
%MVS% %sln% /Clean "Release|Win32" /Out log.txt
if exist "%t2%"	echo **** FAIL: CLEAN: %t2% **********
if exist "%t2%"	echo **** FAIL: CLEAN: %t2% **********							>> log.txt

echo %name%: Building ...

echo.																			>> log.txt
echo **** %name%: Building (Debug) ********************************************	>> log.txt
echo.																			>> log.txt
%MVS% %sln% /Rebuild "Debug|Win32" /Out log.txt
if not exist "%t1%"	echo **** FAIL: BUILD: %t1% **********
if not exist "%t1%"	echo **** FAIL: BUILD: %t1% **********						>> log.txt

echo.																			>> log.txt
echo **** %name%: Building (Release) ******************************************	>> log.txt
echo.																			>> log.txt
%MVS% %sln% /Rebuild "Release|Win32" /Out log.txt
if not exist "%t2%"	echo **** FAIL: BUILD: %t2% **********
if not exist "%t2%"	echo **** FAIL: BUILD: %t2% **********						>> log.txt

echo.																			>> log.txt
echo **** %name%: Done ********************************************************	>> log.txt
goto exit



:dir
echo **************************************************************************
echo The directory specified by argument #3 was not found.
echo dir=%dir%
echo **************************************************************************
goto exit



:mvs
echo **************************************************************************
echo The script variable MVS points to Visual Studio 2008.
echo The referenced executable file was not found.
echo MVS=%MVS%
echo **************************************************************************
goto exit



:sln
echo **************************************************************************
echo A solution file was not found.
echo sln=%sln%
echo **************************************************************************
goto exit



:work_1
echo **************************************************************************
echo Argument #1 must be "work" (wothout quotes) or it must be blank.
echo **************************************************************************
goto exit



:work_2
echo **************************************************************************
echo Argument #2 must specify the name of the target.
echo **************************************************************************
goto exit



:work_3
echo **************************************************************************
echo Argument #3 must specify the relative directory path to the solution file, without a trailing slash.
echo **************************************************************************
goto exit



:work_4
echo **************************************************************************
echo Argument #4 must specify the name of the solution file.
echo **************************************************************************
goto exit



:work_5
echo **************************************************************************
echo Argument #5 must specify the name of the first build target.
echo **************************************************************************
goto exit



:work_6
echo **************************************************************************
echo Argument #6 must specify the name of the second build target, which may be identical to the first.
echo **************************************************************************
goto exit



:end
rem pause
rem edit log.txt

:exit
