// $URL: http://subversion:8080/svn/gsc/trunk/drivers/gsc_common/driver/intime/os_write.c $
// $Rev: 19616 $
// $Date: 2012-11-03 16:41:25 -0500 (Sat, 03 Nov 2012) $

// INtime 4 driver

#include "main.h"



//*****************************************************************************
long os_write(GSC_ALT_STRUCT_T* alt, const void* buf, size_t count)
{
#if defined(DEV_SUPPORTS_WRITE)

	long	ret;

	if (alt)
	{
		alt->tx.non_blocking	= 0;
		ret	= gsc_write(alt, buf, count);
	}
	else
	{
		// The referenced device doesn't exist.
		ret	= -ENODEV;
	}

	return(ret);
#else
    return (-EPERM);
#endif
}


