// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/SIO4%20and%20SIO8/SIO4_Linux_2.x.x_GSC_DN/hdlc/utils/hdlc_util_rx_frame.c $
// $Rev: 23021 $
// $Date: 2013-08-27 14:50:49 -0500 (Tue, 27 Aug 2013) $

#include "sio4_hdlc_utils.h"



//*****************************************************************************
int hdlc_util_rx_frame(int fd, int index, int verbose, sio4_hdlc_rx_frame_t* rx)
{
	int	errs;
	int	ret;

	if (verbose)
		gsc_label_index("HDLC Rx Frame", index);

	ret		= sio4_hdlc_rx_frame(fd, rx);
	errs	= (ret < 0) ? 1 : 0;

	if (verbose == 0)
		;
	else if (errs)
		printf("FAIL <---  (sio4_hdlc_rx_frame, errno %d)\n", -ret);
	else
		printf("PASS\n");

	return(errs);
}


