// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/SIO4%20and%20SIO8/SIO4_Linux_2.x.x_GSC_DN/sync/syncc2c/main.h $
// $Rev: 25414 $
// $Date: 2014-02-26 13:52:18 -0600 (Wed, 26 Feb 2014) $

#ifndef __MAIN_H__
#define __MAIN_H__

#include <ctype.h>
#include <stdlib.h>

#include "sio4_lib.h"
#include "sio4_dsl.h"
#include "sio4_utils.h"
#include "sio4_sync_dsl.h"
#include "sio4_sync_utils.h"


// #defines *******************************************************************

#define	VERSION			"1.17"
// 1.17	Additional LINTing.
// 1.16	LINTing for INtime.
//		Corrected index number in board identification output.
// 1.15	Made mods per changes to common utility code.
//		EXIT_FAILURE is now returned for any error occurrence.
//		Updated some output text.
//		Updated the prototype for sio4_id_board.
//		Updated the help text.
//		LINTed the sources.
//		Updated open/close error processing.
//		Corrected continuous testing error when using the -C command line option.
//		Corrected configuration settings.
// 1.14	Code cleanup.
//		Merge of limited content from the Linux only source tree.
//		Renamed library base name to sio4_sync.
// 1.13	Ported to the 2.x series driver.
// 1.12	Renamed application anme to "syncc2c".
// 1.11	Removed termination configuration as it isn't in the SYNC boards.
// 1.10	Updated per changes in the header file organization.
// 1.9	Updated the identification information reported at program start.
// 1.8	Made spelling correction in output.
// 1.07	Simplified data transfer test.
// 1.06	Added a micro sleep to the tx threat so it doesn't hog time.
// 1.05	Updated device identification information.
// 1.04	Updated decoding of the Features register.
// 1.03	Fixed a bug in interpreting the FRR.
//		Updated the meaning of the SIO4_FEATURE_FIFO_EXT feature.
// 1.02	Added id_fifos() and more features to the driver and the utilities.
// 1.01	The MP setup is now done even for loop back mode.
//		Updated the id_board() utility service.
// 1.00	Initial release.



// variables ******************************************************************

extern	int	rx_index;
extern	int	tx_index;



// prototypes *****************************************************************

int	io_test(int tx, int rx);



#endif
